=== lib/jsoncpp/CMakeLists.txt ===
add_library(jsoncpp STATIC jsoncpp.cpp)
target_link_libraries(jsoncpp)
